program pe_rec(input,output);

**********************************************************************
*                                                                    *
* SURVEY OF CONSUMER FINANCES            EMPLOYER SPONSORED PENSIONS *
*                                                                    *
*                     BENEFIT ESTIMATION PROGRAM                     *
*                                                                    *
* RICHARD CURTIN                                     PAUL PICKELMANN *
*                                                    SCOT ALLEN      *
*                                                                    *
*                (c) 1986  THE UNIVERSITY OF MICHIGAN                *
*                                                                    *
**********************************************************************

 READS PP OUTPUT, SORTS, AND BUILDS PERSON RECORDS 
type
  shortline = packed record
              xxx1: packed array1..3 of char;
              hhid: packed array1..5 of char;
              xxx2: packed array1..135of char;
              pass: packed array1..132of char;
 MUST SPECIFY COMBINED WIDTH OF ALL PASS THROUGH VARIABLES
  AS THE UPPER BOUND IN THE RANGE ABOVE                     
              end;
  shortnopt = packed record
              xxx1: packed array1..3 of char;
              hhid: packed array1..5 of char;
              xxx2: packed array1..135of char;
              end;
  longline  = packed record
              hhid : packed array1..5 of char;
              line1: array1..4 of shortnopt;
              pt1  : packed array1..132 of char;
              end;
  listtype =  array1..1793 of shortline;
 MUST SPECIFY UPPER BOUND OF RANGE ABOVE AT LEAST EQUAL
  TO ONE PLUS THE NUMBER OF LINES IN THE INPUT FILE         
const
  s0 = shortnopt('   ','00000',
          '  000   00 0 0000000 0000000 0000000 0000000  0000000000  '
       !! '00000  00000 00  00000  00000 000000  00000    0000000    00000000   00000000');
  pt = '                                                  '
     !!'                                                  '
     !!'                                ';
 THE NUMBER OF BLANKS IN QUOTES ABOVE MUST MATCH THE
  COMBINED WIDTH OF PASS THROUGH VARIABLES GIVEN ABOVE      
  l0 = longline('    ',(s0,s0,s0,s0),pt);
var
  input:  text;
  output: file of longline;
  hh :     packed array1..5 of char;
   r:     integer;
   list: listtype;


procedure interchange(var line1, line2 : shortline);

var
   dummy : shortline;

begin
   dummy := line1;
   line1 := line2;
   line2 := dummy;
end;


procedure qsort(var list:listtype ; m,n : integer);
var
   i,j : integer;
   k : packed array1..5 of char;

begin
   if m < n
      then
         begin
            i := m; j := n + 1; k := listm.hhid;
            repeat
               repeat
                  i := i + 1;
               until listi.hhid >= k;
               repeat
                  j := j - 1;
               until listj.hhid <= k;
               if i < j
                  then
                     interchange(listi, listj);
            until i >= j;
            interchange(listm,listj);
            qsort(list, m, j-1);       Go sort left half
            qsort(list, j+1, n);       Go sort right half
         end;
end;

function nopt(inline:shortline):shortnopt;

begin
   nopt.xxx1 := inline.xxx1;
   nopt.hhid := inline.hhid;
   nopt.xxx2 := inline.xxx2;
end;

procedure combine;

var
   s : 0..4;
   t : integer;

begin
rewrite(output,'unit=sprint');
t := 1;
while t <= r do begin
  hh := listt.hhid;
  s := 0;  output@ := l0;  output@.hhid := hh;
  repeat
    s := s + 1;
    output@.pt1 := listt.pass; output@.line1s := nopt(listt);
    t := t + 1;
    until (t > r) or (listt.hhid<>hh);
  put(output);
  end;
end;

 PROGRAM CONTROL STATEMENTS 
begin
r := 0;
reset(input,'unit=scards');
while not eof(input) do begin
      r := r + 1;
      readln(input,listr.xxx1,listr.hhid,listr.xxx2,listr.pass);
      end;
listr+1.hhid := '99999';
qsort(list,1,r);
combine;

end.
